unit DBWebControl1;

interface
  uses System.Web.UI, System.Web.UI.WebControls,
  System.ComponentModel, System.Collections.Specialized,
  System.Drawing.Design, System.IO, Borland.Data.Web,
  eBob42.NicerLabelControl, System.Drawing;

type
//   [ToolboxBitmap(typeof(DBWebNicerLabelControl)]
//   ['DBWebNicerLabelControl.bmp')]
	[Designer('Borland.Data.Web.DBWebControlDesigner')]
	[ToolboxData('<{0}:DBWebNicerLabelControl runat=server></{0}:DBWebNicerLabelControl>')]
  DBWebNicerLabelControl = class(System.Web.UI.WebControls.WebControl, IPostBackDataHandler, IDBWebColumnLink, INamingContainer)
  strict private
    FMyDelegate: NicerLabelControl; // or whatever control or controls you want to use to render your control.
  strict protected
    // Override Render when descending directly from ASP.NET Control
    // procedure Render(Output: HtmlTextWriter); override;

    // Override RenderContents when descending from ASP.NET WebControl
    procedure RenderContents(Output: HtmlTextWriter); override;
  public
    constructor Create;
  // Implement code from this region for controls that use the DB Web interfaces
  strict protected
    procedure OnInit(e: EventArgs); override;
    procedure OnPreRender(args: EventArgs); override;
    // For more information on IPostBackDataHandler, see the help entry
    // ms-help://borland.bds2/cpref/html/frlrfSystemWebUIIPostBackDataHandlerClassLoadPostDataTopic.htm
    function LoadPostData(postDataKey: string;
      postCollection: NameValueCollection) : boolean;
    procedure RaisePostDataChangedEvent;

  // IDBWebDataLink is the core interface for the DB Web controls
  // and must be implemented for all DB Web controls

  private
    FDataLink: DBWebDataLink;
    FIDataLink: IDBWebDataLink;
    function GetTableName: string;
    procedure SetTableName(Value: string);
    function GetDataSource: IDBDataSource;
    procedure SetDataSource(Value: IDBDataSource);
    function GetText: string;
  protected
    property Text: string read GetText;
  public
    property IDataLink: IDBWebDataLink read FIDataLink;
    procedure DataBind; override;

  published
    [Editor(typeof(Borland.Data.Web.TableNamePropEditor), typeof(UITypeEditor)),
  		LocalizableCategoryAttribute('DBWebControl'),
  		DefaultValue('')]
    property TableName: string read GetTableName write SetTableName;
		[LocalizableCategoryAttribute('DBWebControl'),
  		DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden),
  		DefaultValue('')]
    property DBDataSource: IDBDataSource read GetDataSource write SetDataSource;

  {$REGION 'IDBWebColumnLink declarations'}
  // IDBWebColumnLink is used to databind to a specific column (optional)
  private // Should this be strict private?
    FIColumnLink: IDBWebColumnLink;
    function GetIColumnLink : IDBWebColumnLink;
    function GetColumnName: string;
    procedure SetColumnName(Value: string);
  public
    property IColumnLink: IDBWebColumnLink read GetIColumnLink;
    function get_ColorEnd: Color;
    function get_ColorBegin: COlor;
    procedure set_ColorEnd(Value: Color);
    procedure set_ColorBegin(Value: Color);
  published
    [Editor(typeof(Borland.Data.Web.ColumnNamePropEditor), typeof(UITypeEditor)),
  		LocalizableCategoryAttribute('DBWebControl'),
  		DefaultValue('')]
    property ColumnName: string read GetColumnName write SetColumnName;



    [Category('eBob42')]
    property ColorEnd: Color read get_ColorEnd write set_ColorEnd;
    [Category('eBob42')]
    property ColorBegin: Color read get_ColorBegin write set_ColorBegin;

  {$ENDREGION}

  end;

implementation

{$REGION 'Control.Render override'}

(*
/// <summary>
/// The override for Render should be used when descending directly from
/// System.Web.UI.WebControls.Control, or when creating a composite control
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure DBWebNicerLabelControl.Render(Output: HtmlTextWriter);
begin
  Output.Write(Text);
end;
(**)
{$ENDREGION}

{$REGION 'WebControl.RenderContents override'}
/// <summary>
/// Render this control to the output parameter specified.
/// The override for RenderContents should be used when descending from
/// System.Web.UI.WebControls.WebControl so all cosmetic attributed
/// are rendered appropriately for the control
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure DBWebNicerLabelControl.RenderContents(Output: HtmlTextWriter);
begin
  Output.Write(Text);
end;
{$ENDREGION}

{$REGION 'DB Web control implementation'}
// For all DB web control implementations, the IDBWebDataLink implementation
// region is required. Furthermore, the IDBWebColumnLink region is required
// for components that implement the IDBWebLookupColumnLink.
{$REGION 'IDBWebDataLink implementation'}
/// <summary>
// Construct the required private instance variables, depending on the
// defined options for this control.
/// Use this procedure if IDBWebDataLink interface is implemented
/// </summary>
constructor DBWebNicerLabelControl.Create;
begin
  inherited;
  FMyDelegate := NicerLabelControl.Create;  // or whatever control or controls you want to render your control;
  FDataLink := DBWebColumnLink.Create(self);
  FIColumnLink := (FDataLink as IDBWebColumnLink);
  // Standard DB Web interface should always be defined
  FIDataLink := (FDataLink as IDBWebDataLink);
end;

/// <summary>
/// Override the default initialization method to require postback
/// </summary>
procedure DBWebNicerLabelControl.OnInit(e: EventArgs);
begin
  inherited OnInit(e);
  if Assigned(Page) then
    Page.RegisterRequiresPostBack(self);
end;

/// <summary>
/// Register control as DBWebControl associated with a specific table
/// </summary>
procedure DBWebNicerLabelControl.OnPreRender(args: EventArgs);
begin
  inherited OnPreRender(args);
  // You need to register the hidden field to identify the key for
  // read-write controls only. Remove this call if control is read-only.
  Page.RegisterHiddenField(DBWebDataSource.IdentPrefix + DBWebConst.Splitter
    + IDataLink.TableName, self.ID);
  DataBind;
end;

function DBWebNicerLabelControl.GetText: string;
var
  sw: StringWriter;
  tw: HtmlTextWriter;
begin
	sw := StringWriter.Create;
	tw := HtmlTextWriter.Create(sw);
	DataBind();
	FMyDelegate.RenderControl(tw);
	Result := sw.ToString();
end;

// RaisePostDataChangedEvent is called prior to DataBind()
// DataSet and related properties are NOT available here
// Child controls are not available
function DBWebNicerLabelControl.LoadPostData(postDataKey:string;
  postCollection: NameValueCollection) : boolean;
begin
  FDataLink.LoadPostData(postDataKey, postCollection);
  // set to true if you intend to use RaisePostDataChangedEvent;
  Result := false;
end;

procedure DBWebNicerLabelControl.RaisePostDataChangedEvent;
begin
  // Put custom data change handling code here
end;

// IDBWebDataLink setters/getters
function DBWebNicerLabelControl.GetTableName: string;
begin
  Result := FIDataLink.TableName;
end;

procedure DBWebNicerLabelControl.SetTableName(Value: string);
begin
  FIDataLink.TableName := Value;
end;

function DBWebNicerLabelControl.GetDataSource: IDBDataSource;
begin
  Result := FIDataLink.DBDataSource;
end;

procedure DBWebNicerLabelControl.SetDataSource(Value: IDBDataSource);
begin
  FIDataLink.DBDataSource := Value;
end;

procedure DBWebNicerLabelControl.DataBind;
var
  obj: System.Object;
begin
  try
    // DataBind whatever properties you require wherever you see
    // See the C# source code for DBWebNavigator and DBWebLabeledTextBox
    // for additional examples.

    // Set value to blank if not data bound

    // call to inherited triggers setting of DBDataSource.
		inherited DataBind;
    if FDataLink.IsDataBound then
    begin
      obj := FIColumnLink.DBDataSource.GetColumnValue(Page,
        FIColumnLink.TableName, FIColumnLink.ColumnName);
      if Assigned(obj) then
      begin
		    FMyDelegate.Text := Convert.ToString(obj);
			  inherited DataBind;
      end
    end;
  except
  on E: Exception do
	begin
    if (not ClassUtils.IsDesignTime(Page)) then
				Page.Response.Write(ClassUtils.GetInternalError(Page, FIDataLink, E,
        Self.ID))
    else
		  Raise Exception(E);
  end;
end;

end;
{$ENDREGION}

{$REGION 'IDBWebColumnLink implementation'}
function DBWebNicerLabelControl.GetIColumnLink : IDBWebColumnLink;
begin
  Result := FIColumnLink; // Could be weak referenced instead
end;

function DBWebNicerLabelControl.GetColumnName: string;
begin
  Result := IColumnLink.ColumnName;
end;

procedure DBWebNicerLabelControl.SetColumnName(Value: string);
begin
  IColumnLink.ColumnName := Value;
end;
{$ENDREGION}

function DBWebNicerLabelControl.get_ColorEnd: Color;
begin
  Result := FMyDelegate.ForeColorEnd
end;

function DBWebNicerLabelControl.get_ColorBegin: COlor;
begin
  Result := FMyDelegate.ForeColor
end;

procedure DBWebNicerLabelControl.set_ColorEnd(Value: Color);
begin
  FMyDelegate.ForeColorEnd := Value
end;

procedure DBWebNicerLabelControl.set_ColorBegin(Value: Color);
begin
  FMyDelegate.ForeColor := Value;
end;




{$REGION 'IDBWebLookupColumnLink implementation'}
{$ENDREGION}

{$ENDREGION}

end.

