unit LogoutControl;
interface
uses System.Data, System.Drawing, System.Web, System.Web.UI,
     System.Web.UI.WebControls, System.Web.UI.HtmlControls;

type
    /// <summary>
    /// Summary description for WebUserControl1.
    /// </summary>
  LogoutUserControl = class(System.Web.UI.UserControl)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure btnLogout_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    lbLogin: System.Web.UI.WebControls.Label;
    btnLogout: System.Web.UI.WebControls.Button;
    procedure OnInit(e: System.EventArgs); override;
  private
    { Private Declarations }
    FLogout: EventHandler;
  public
    procedure set_LoginName(const Value: String);
  public
    { Public Declarations }
    property Logout: EventHandler add FLogout remove FLogout;
    property LoginName: String write set_LoginName; // write-only!!
  end;

implementation
uses
  System.Web.Security;

procedure LogoutUserControl.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  // TODO: Put user code to initialize the page here
  lbLogin.Text := Page.User.Identity.Name
end;

procedure LogoutUserControl.OnInit(e: System.EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure LogoutUserControl.btnLogout_Click(sender: System.Object; e: System.EventArgs);
begin
  FormsAuthentication.SignOut;
  lbLogin.Text := ''; // clear
  if Assigned(FLogout) then FLogout(Sender, e)
end;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure LogoutUserControl.InitializeComponent;
begin
  Include(Self.btnLogout.Click, Self.btnLogout_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}


procedure LogoutUserControl.set_LoginName(const Value: String);
begin
  lbLogin.Text := 'Welcome ' + Value
end;

end.
