unit Oblong.TemperatureEditor;

interface

uses
  System.ComponentModel.Design;

type
  TemperatureEditor = class(ComponentDesigner)
  protected
    procedure AbsoluteZeroVerb(Sender: &Object; e: EventArgs);
    procedure FreezingVerb(Sender: &Object; e: EventArgs);
    procedure BoilingVerb(Sender: &Object; e: EventArgs);
  public
    function get_Verbs: DesignerVerbCollection; override;
  end;

implementation

uses
  Oblong.Temperature, System.Windows.Forms;

{ TemperatureEditor }

procedure TemperatureEditor.FreezingVerb(Sender: &Object; e: EventArgs);
begin
  Temperature(Component).Kelvin := 273.15;
end;

procedure TemperatureEditor.BoilingVerb(Sender: &Object; e: EventArgs);
begin
  Temperature(Component).Kelvin := 373.15;
end;

procedure TemperatureEditor.AbsoluteZeroVerb(Sender: &Object; e: EventArgs);
begin
  Temperature(Component).Kelvin := 0
end;

function TemperatureEditor.get_Verbs: DesignerVerbCollection;
var
  Verbs: array[0..2] of DesignerVerb;
begin
  Verbs[0] := DesignerVerb.Create('Absolute zero', AbsoluteZeroVerb);
  Verbs[1] := DesignerVerb.Create('Freezing point', FreezingVerb);
  Verbs[2] := DesignerVerb.Create('Boiling point', BoilingVerb);
  Result := DesignerVerbCollection.Create(Verbs)
end;

end.
