unit eBob42.Navigator;
interface
uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  Navigator = class(System.Windows.Forms.UserControl)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnFirst: System.Windows.Forms.Button;
    btnPrev: System.Windows.Forms.Button;
    btnNext: System.Windows.Forms.Button;
    btnLast: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnFirst_Click(sender: System.Object; e: System.EventArgs);
    procedure btnPrev_Click(sender: System.Object; e: System.EventArgs);
    procedure btnNext_Click(sender: System.Object; e: System.EventArgs);
    procedure btnLast_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    CurrManager: CurrencyManager;
    FDataSource: DataSet;
    FDataMember: String;
    FActive: Boolean;
  public
    constructor Create;
    procedure set_Active(const Value: Boolean);
    property Active: Boolean read FActive write set_Active;
  published
    procedure set_DataMember(const Value: String);
    procedure set_DataSource(const Value: DataSet);
    property DataSource: DataSet read FDataSource write set_DataSource;
    property DataMember: String read FDataMember write set_DataMember;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(Navigator))]

implementation

uses
  System.Globalization;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure Navigator.InitializeComponent;
begin
  Self.btnFirst := System.Windows.Forms.Button.Create;
  Self.btnPrev := System.Windows.Forms.Button.Create;
  Self.btnNext := System.Windows.Forms.Button.Create;
  Self.btnLast := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // btnFirst
  // 
  Self.btnFirst.Location := System.Drawing.Point.Create(0, 0);
  Self.btnFirst.Name := 'btnFirst';
  Self.btnFirst.Size := System.Drawing.Size.Create(72, 24);
  Self.btnFirst.TabIndex := 0;
  Self.btnFirst.Text := 'First';
  Include(Self.btnFirst.Click, Self.btnFirst_Click);
  // 
  // btnPrev
  // 
  Self.btnPrev.Location := System.Drawing.Point.Create(80, 0);
  Self.btnPrev.Name := 'btnPrev';
  Self.btnPrev.Size := System.Drawing.Size.Create(72, 24);
  Self.btnPrev.TabIndex := 1;
  Self.btnPrev.Text := 'Prev';
  Include(Self.btnPrev.Click, Self.btnPrev_Click);
  // 
  // btnNext
  // 
  Self.btnNext.Location := System.Drawing.Point.Create(160, 0);
  Self.btnNext.Name := 'btnNext';
  Self.btnNext.Size := System.Drawing.Size.Create(72, 24);
  Self.btnNext.TabIndex := 2;
  Self.btnNext.Text := 'Next';
  Include(Self.btnNext.Click, Self.btnNext_Click);
  // 
  // btnLast
  // 
  Self.btnLast.Location := System.Drawing.Point.Create(240, 0);
  Self.btnLast.Name := 'btnLast';
  Self.btnLast.Size := System.Drawing.Size.Create(72, 24);
  Self.btnLast.TabIndex := 3;
  Self.btnLast.Text := 'Last';
  Include(Self.btnLast.Click, Self.btnLast_Click);
  // 
  // Navigator
  // 
  Self.Controls.Add(Self.btnLast);
  Self.Controls.Add(Self.btnNext);
  Self.Controls.Add(Self.btnPrev);
  Self.Controls.Add(Self.btnFirst);
  Self.Name := 'Navigator';
  Self.Size := System.Drawing.Size.Create(320, 24);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

constructor Navigator.Create;
begin
  inherited Create;
  FDataSource := nil;
  FDataMember := '';
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure Navigator.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

procedure Navigator.set_DataMember(const Value: String);
begin
  FDataMember := Value;
  Active := False;
end;

procedure Navigator.set_DataSource(const Value: DataSet);
begin
  FDataSource := Value;
  Active := False;
end;

procedure Navigator.btnLast_Click(sender: System.Object; e: System.EventArgs);
begin
  if Assigned(CurrManager) then
    CurrManager.Position := CurrManager.Count-1
end;

procedure Navigator.btnNext_Click(sender: System.Object; e: System.EventArgs);
begin
  if Assigned(CurrManager) then
    if CurrManager.Position < CurrManager.Count-1 then
      CurrManager.Position := CurrManager.Position + 1
end;

procedure Navigator.btnPrev_Click(sender: System.Object; e: System.EventArgs);
begin
  if Assigned(CurrManager) then
    if CurrManager.Position > 0 then
      CurrManager.Position := CurrManager.Position - 1
end;

procedure Navigator.btnFirst_Click(sender: System.Object; e: System.EventArgs);
begin
  if Assigned(CurrManager) then
    CurrManager.Position := 0
end;

procedure Navigator.set_Active(const Value: Boolean);
begin
  FActive := Value;
  if FActive then
  try
    if Assigned(FDataSource) and (FDataMember <> '') then
      CurrManager := Parent.BindingContext[FDataSource, FDataMember] as CurrencyManager
  except
    FActive := False
  end;
  if not FActive then CurrManager := nil
end;

end.
