unit eBob42.DBRecordInfo;
interface
uses
  SysUtils, Classes, Controls, StdCtrls,
  DB, DBCtrls;

type
  TDBRecordInfo = class(TStaticText)
  private
    { Private declarations }
    FDataLink: TFieldDataLink;
    function GetDataSource: TDataSource;
    procedure SetDataSource(const Value: TDataSource);
  protected
    { Protected declarations }
    procedure DataChange(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    { Public declarations }
  published
    { Published declarations }
    property DataSource: TDataSource read GetDataSource write SetDataSource;
  end;

implementation

{ TDBRecordInfo }

constructor TDBRecordInfo.Create(AOwner: TComponent);
begin
  inherited;
  FDataLink := TFieldDataLink.Create;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnActiveChange := DataChange
end;

procedure TDBRecordInfo.DataChange(Sender: TObject);
var
  DataSet: TDataSet;
begin
  if Assigned(FDataLink) then
    if Assigned(FDataLink.DataSource) then
      if Assigned(FDataLink.DataSource.DataSet) then
      begin
        DataSet := FDataLink.DataSource.DataSet;
        if DataSet.Active then
          Caption := Format('%d/%d',[DataSet.RecNo,DataSet.RecordCount])
        else
          Caption := Format('0/%d',[FDataLink.RecordCount])
      end
      else Caption := 'n/a'
    else Caption := '/'
  else Caption := '?'
end;

destructor TDBRecordInfo.Destroy;
begin
  FDataLink.Free;
  inherited
end;

function TDBRecordInfo.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource
end;

procedure TDBRecordInfo.SetDataSource(const Value: TDataSource);
begin
  FDataLink.DataSource := Value
end;

end.
